diff a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/oops/Oop.java b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/oops/Oop.java
--- a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/oops/Oop.java
+++ b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/oops/Oop.java
@@ -45,12 +45,11 @@
 
   private static synchronized void initialize(TypeDataBase db) throws WrongTypeException {
     Type type  = db.lookupType("oopDesc");
     mark       = new CIntField(type.getCIntegerField("_mark"), 0);
     if (VM.getVM().isCompactObjectHeadersEnabled()) {
-      Type markType = db.lookupType("markWord");
-      headerSize = markType.getSize();
+      headerSize = 4;
     } else {
       headerSize = type.getSize();
       klass      = new MetadataField(type.getAddressField("_metadata._klass"), 0);
       compressedKlass  = new NarrowKlassField(type.getAddressField("_metadata._compressed_klass"), 0);
     }
@@ -130,10 +129,14 @@
 
   public int hashCode() { return getHandle().hashCode(); }
 
   /** Identity hash in the target VM */
   public long identityHash() {
+    if (VM.getVM().isCompactObjectHeadersEnabled()) {
+      System.exit(-23);
+        throw new InternalError("Not yet implemented");
+    }
     Mark mark = getMark();
     if (mark.isUnlocked() && (!mark.hasNoHash())) {
       return (int) mark.hash();
     } else if (mark.isMarked()) {
       return (int) mark.hash();
